Subject: Re: bug#71518: 30.0.50; Errors during redisplay with c++-ts-mode

From: Yuan Fu <[email-masked]>
Date: Wed, 12 Jun 2024 23:51:21 -0700

> On Jun 12, 2024, at 6:53 AM, Vincenzo Pupillo <[email-masked]> wrote:
> 
> 
> In data mercoledì 12 giugno 2024 14:33:17 CEST, Eli Zaretskii ha scritto:
>> To reproduce in "emacs -Q", visit some C++ source file (I used
>> breakpoint.c from the GDB sources), then turn on c++-ts-mode.  The
>> fontification is all incorrect, and *Messages* has these error
>> messages:
>> 
>>  Error during redisplay: (jit-lock-function 7286) signaled (treesit-query-error "Node type error at" 575 "[\"_Atomic\" \"break\" \"case\" \"const\" \"continue\" \"default\" \"do\" \"else\" \"enum\" \"extern\" \"for\" \"goto\" \"if\" \"inline\" \"register\" \"restrict\" \"return\" \"sizeof\" \"static\" \"struct\" \"switch\" \"typedef\" \"union\" \"volatile\" \"while\" \"and\" \"and_eq\" \"bitand\" \"bitor\" \"catch\" \"class\" \"co_await\" \"co_return\" \"co_yield\" \"compl\" \"concept\" \"consteval\" \"constexpr\" \"constinit\" \"decltype\" \"delete\" \"explicit\" \"final\" \"friend\" \"mutable\" \"namespace\" \"new\" \"noexcept\" \"not\" \"not_eq\" \"operator\" \"or\" \"or_eq\" \"override\" \"private\" \"protected\" \"public\" \"requires\" \"template\" \"throw\" \"try\" \"typename\" \"using\" \"virtual\" \"xor\" \"xor_eq\"] @font-lock-keyword-face (auto) @font-lock-keyword-face (this) @font-lock-keyword-face" "Debug the query with `treesit-query-validate'")
>> 
>> This happens with the latest C++ tree-sitter grammar library.  I guess
>> they made some incompatible change in the grammar or something?
>> 
>> 
> Yes, they changed the grammar. 
> https://github.com/tree-sitter/tree-sitter-cpp/issues/271
> 
> V.

So it seems “virtual” is now a named node rather than an anonymous node, which is a little odd. I asked the author about it in the GitHub issue, let me clear that up before fixing c-ts-mode.

And, Eli, we really really should pin tree-sitter grammars. As more people start using tree-sitter modes, they will found out about the breakage before we do and the tree-sitter major mode would be unusable for them before they upgrade their grammar. Most of them will not know how to do it and which commit to downgrade to. And I really don’t want to chase the random changes these grammars make all the time. Fixing for these breakages is arguably a heavier maintenance burden than pinning tree-sitter grammars.

Yuan